<?php
include_once(realpath(dirname(__FILE__)) . "./BaseobjLMB.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Client.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Cnx.class.php");

/**
 * Classe qui permet de synchroniser les clients vers l'application Lundi Matin Business
 *
 * @author Damien CELLE, Thibault GRILLE, Florian MERCIER, Jonathan PERICHON
 */
class ClientLMB extends BaseobjLMB {
        var $tmpcli; // client thelia
        var $cnxThelia; // connexion  la base de thelia
        var $date; // date
        var $ref_adresse;
        var $ref_contact;
        var $ref_coord;

        /* Champs concernant la table Adresses de la base de donnes Lundi Matin Business */
        var $bddvarsAdresses = array("ref_adresse", "ref_contact", "lib_adresse", "text_adresse", "code_postal", "ville", "id_pays", "note", "ordre");
        var $bddvalsAdresses;
        var $tableAdresses = "adresses";

        /* Champs concernant la table Annuaire de la base de donnes Lundi Matin Business */
        var $bddvarsAnnuaire = array("ref_contact", "id_civilite", "nom", "id_categorie", "siret", "tva_intra", "note", "date_creation", "date_modification");
        var $bddvalsAnnuaire;
        var $tableAnnuaire = "annuaire";

        /* Champs concernant la table Coordonnees de la base de donnes Lundi Matin Business */
        var $bddvarsCoordonnees = array("ref_coord", "ref_contact", "lib_coord", "tel1", "tel2", "fax", "email", "note", "ordre");
        var $bddvalsCoordonnees;
        var $tableCoordonnees = "coordonnees";

        /* Champs concernant la table Annuaire_profils de la base de donnes Lundi Matin Business */
        var $bddvarsAnnuaire_profils = array("ref_contact", "id_profil");
        var $bddvalsAnnuaire_profils;
        var $tablesAnnuaire_profils = "annuaire_profils";

        /* Champs concernant la table Annu_client de la base de donnes Lundi Matin Business */
        var $bddvarsAnnu_client = array("ref_contact", "id_client_categ", "type_client", "id_tarif", "ref_adr_livraison", "ref_adr_facturation", "app_tarifs", "factures_par_mois", "encours", "delai_reglement", "defaut_numero_compte");
        var $bddvalsAnnu_client;
        var $tableAnnu_client = "annu_client";

        /* Tables dans lesquelles insrer du ct de Lundi Matin Business */
        var $tablesLMB = array("annuaire", "adresses", "coordonnees", "annuaire_profils", "annu_client");

        /**
         * Constructeur
         * @param $email l'email du client Thelia, qui permettra de le charger entierement
         */
        function ClientLMB($email) {
                $this->BaseObjLMB();
                $this->tmpcli = new Client();
                $this->tmpcli->charger_mail($email);
                $this->date = date("Y-m-d H:i:s");
        }

        /**
         * Mise en forme pour la table Annuaire
         */
        function miseEnFormeAnnuaire() {
                //ref_contact
                $this->ref_contact = $this->transform1lettersIdContact('C');
                //id_civilite
                switch ($this->tmpcli->raison) {
                        case 1:
                                $id_civilite = 2;
                                break;
                        case 2:
                                $id_civilite = 7;
                                break;
                        case 3:
                                $id_civilite = 1;
                                break;
                }

                //id_categorie
                $id_categorie = 1;
                //nom
                $nom = $this->tmpcli->nom . " " . $this->tmpcli->prenom;

                $this->bddvalsAnnuaire = array($this->ref_contact, $id_civilite, $nom, $id_categorie, $this->tmpcli->siret, $this->tmpcli->intracom, "", $this->date, $this->date);
        }

        /**
         * Mise en forme pour la table Adresses
         */
        function miseEnFormeAdresses() {
                //ref_adresse
                $this->ref_adresse = $this->transform3lettersIdAdresse("ADR");
                // libell
                $lib_adresse = "Domicile";

                $this->cnxThelia = new Cnx();
                //Rcupration du nom du pays (en majuscule)
                $query = "select titre from paysdesc where id = " . $this->tmpcli->pays;
                $resul = mysql_query($query, $this->cnxThelia->link);
                $pays = mysql_result($resul, 0);
                //$pays = strtoupper($pays);
				if($pays == "France mtropolitaine")
					$pays = "FRANCE";
				else
					$pays = strtoupper($pays);
                //pays : $paysThelia contient le nom du pays en majuscule, il faut donc trouver son id correspondant
                $query = "select id_pays from ".$this->bddLMB.".pays where pays = '$pays'";
                $resul = mysql_query($query, $this->linkLMB);
                $id_pays = mysql_result($resul, 0);
                mysql_close($this->cnxThelia->link);
                //Si le pays rcuprer depusi Thelia n'existe pas dans la base de Lundi Matin Business, on assigne  la France par dfaut
                if (empty($id_pays)) {
                        $id_pays = 77;
                }

                $this->bddvalsAdresses = array($this->ref_adresse, $this->ref_contact, $lib_adresse, $this->tmpcli->adresse1, $this->tmpcli->cpostal, $this->tmpcli->ville, $id_pays, "", 1);
        }

        /**
         * Mise en forme pour la table Coordonnees
         */
        function miseEnFormeCoordonnees() {
                //ref_coord
                $this->ref_coord = $this->transform3lettersIdCoordonnees("COO");
                //lib_coord
                $lib_coord = "Domicile";

                $this->bddvalsCoordonnees = array($this->ref_coord, $this->ref_contact, $lib_coord, $this->tmpcli->telfixe, $this->tmpcli->telport, "", $this->tmpcli->email, "", 1);
        }

        /**
         * Mise en forme pour la table Coordonnees
         */
        function miseEnFormeAnnuaire_profils() {
                // profil avec id = 4 => client
                $id_profil = 4;
                $this->bddvalsAnnuaire_profils = array($this->ref_contact, $id_profil);
        }

        /**
         * Mise en forme pour la table Annu_client
         */
        function miseEnFormeAnnu_client() {
                $id_client_categ = 1; //
                $type_client = "client";
                $id_tarif = 1;
                $app_tarifs = "TTC";

                $this->bddvalsAnnu_client = array($this->ref_contact, $id_client_categ, $type_client, $id_tarif, $this->ref_adresse, $this->ref_adresse, $app_tarifs, 0, 0, 0, "2");
        }
		
		function transform1lettersIdContact($chaine) 
		{
				$this->Cnx();
				$query = "SELECT ref_contact FROM ".$this->bddLMB.".annuaire ORDER BY ref_contact DESC LIMIT 0,1";
				$resul = mysql_query($query,$this->linkLMB);
				$data = mysql_result($resul,0);
				$tab = explode("-",$data);
				if($tab[1] == "000000")
				{
					$max = $tab[2] + 1;
					$max = str_pad($max,strlen($tab[2])-strlen($max), '0', STR_PAD_LEFT);
				}
				else
				{
					$max = $tab[1] + 1;	
					$max = str_pad($max,strlen($tab[1])-strlen($max), '0', STR_PAD_LEFT);
				}
				$length = strlen($max);
				$newId = '';
				$newId = str_pad($newId,11-$length, '0', STR_PAD_LEFT);
				$newId = $chaine.$newId.$max;
				$newId = $this->str_insert('-', $newId, 1);
                $newId= $this->str_insert('-', $newId, 8);
                return $newId;
				
        }
		
		function transform3lettersIdAdresse($chaine) 
		{
				$this->Cnx();
				$query = "SELECT ref_adresse FROM ".$this->bddLMB.".adresses ORDER BY ref_adresse DESC LIMIT 0,1";
				$resul = mysql_query($query,$this->linkLMB);
				$data = mysql_result($resul,0);
				$tab = explode("-",$data);
				if($tab[1] == "000000")
				{
					$max = $tab[2] + 1;
					$max = str_pad($max,strlen($tab[2])-strlen($max), '0', STR_PAD_LEFT);
				}
				else
				{
					$max = $tab[1] + 1;	
					$max = str_pad($max,strlen($tab[1])-strlen($max), '0', STR_PAD_LEFT);
				}
				$length = strlen($max);
				$newId = '';
				$newId = str_pad($newId,11-$length, '0', STR_PAD_LEFT);
				$newId = $chaine.$newId.$max;
				$newId = $this->str_insert('-', $newId, 3);
                $newId= $this->str_insert('-', $newId, 10);
                return $newId;
        }
		
		function transform3lettersIdCoordonnees($chaine) 
		{
				$this->Cnx();
				$query = "SELECT ref_coord FROM ".$this->bddLMB.".coordonnees ORDER BY ref_coord DESC LIMIT 0,1";
				$resul = mysql_query($query,$this->linkLMB);
				$data = mysql_result($resul,0);
				$tab = explode("-",$data);
				if($tab[1] == "000000")
				{
					$max = $tab[2] + 1;
					$max = str_pad($max,strlen($tab[2])-strlen($max), '0', STR_PAD_LEFT);
				}
				else
				{
					$max = $tab[1] + 1;	
					$max = str_pad($max,strlen($tab[1])-strlen($max), '0', STR_PAD_LEFT);
				}
				$length = strlen($max);
				$newId = '';
				$newId = str_pad($newId,11-$length, '0', STR_PAD_LEFT);
				$newId = $chaine.$newId.$max;
				$newId = $this->str_insert('-', $newId, 3);
                $newId= $this->str_insert('-', $newId, 10);
                return $newId;
        }
}
?>
