<?php
include_once(realpath(dirname(__FILE__)) . "./BaseobjLMB.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Commande.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Cnx.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Client.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Produit.class.php");


/**
 * Classe qui permet de synchroniser les commandes vers l'application Lundi Matin Business
 *
 * @author Damien CELLE, Thibault GRILLE, Florian MERCIER, Jonathan PERICHON
 */
class CommandeLMB extends BaseobjLMB {
        var $tmpcmd; // commande thelia
        var $tmpadr; // adresse thelia
        var $tmpcli; // client thelia

        var $cnxThelia; // connexion  la base de thelia
        var $pays; // pays

        var $date; // date actuelle (avec heures, minutes, secondes)
        var $date_simple; // date simple (yyyy-mm-dd)

        var $ref_doc_cdc; // ref pour le bon de commande
        var $ref_contact; // ref_contact
        var $ref_user; // ref_user

        var $prix_total; // prix total de la commande

        var $ref_articles = array(); // tableau contenant toutes les refrences des articles commandes
        var $ref_doc_lines = array(); // tableau contenant toutes les rfrences doc_lines
        var $quantite = array(); // tableau contenant les quantits de chaque produit command
        var $prix = array(); // tableau contenant les prix de chaque produit command
        var $id_vente_prod = array(); // tableau contenant les id de chaque venteprod

        var $id_stock = 1; // id du stock, par dfaut  1
        var $id_magasin = 1; // id du magasin, par dfaut  1

        /* Champs concernant la table Documents de la base de donnes Lundi Matin Business */
        var $bddvarsDocuments = array("ref_doc","id_type_doc","id_etat_doc","ref_contact","nom_contact", "adresse_contact","code_postal_contact","ville_contact","id_pays_contact","app_tarifs","description","date_creation_doc","code_file");
        var $bddvalsDocuments;
        var $tableDocuments = "documents";

        /* Champs concernant la table Doc_cdc de la base de donnes Lundi Matin Business */
        var $bddvarsDoc_cdc = array("ref_doc", "date_livraison", "adresse_livraison", "code_postal_livraison", "ville_livraison", "id_pays_livraison", "id_stock", "id_magasin");
        var $bddvalsDoc_cdc;
        var $tableDoc_cdc = "doc_cdc";

        /* Champs concernant la table Docs_lines de la base de donnes Lundi Matin Business */
        var $bddvarsDocs_lines = array("ref_doc_line", "ref_doc", "ref_article", "lib_article", "desc_article", "qte", "pu_ht", "remise", "tva","visible");
        var $bddvalsDocs_lines1;
        var $bddvalsDocs_lines2;
        var $bddvalsDocs_lines3;
        var $bddvalsDocs_lines4;
        var $bddvalsDocs_lines5;
        var $bddvalsDocs_lines6;
        var $bddvalsDocs_lines7;
        var $bddvalsDocs_lines8;
        var $bddvalsDocs_lines9;
        var $bddvalsDocs_lines10;
        var $bddvalsDocs_lines11;
        var $bddvalsDocs_lines12;
        var $bddvalsDocs_lines13;
        var $bddvalsDocs_lines14;
        var $bddvalsDocs_lines15;
        var $bddvalsDocs_lines16;
        var $tableDocs_lines = "docs_lines";
        var $repeatDocs_lines = 1;

        /* Champs concernant la table Doc_lines_cdc de la base de donnes Lundi Matin Business */
        var $bddvarsDoc_lines_cdc = array("ref_doc_line", "qte_livree");
        var $bddvalsDoc_lines_cdc1;
        var $bddvalsDoc_lines_cdc2;
        var $bddvalsDoc_lines_cdc3;
        var $bddvalsDoc_lines_cdc4;
        var $bddvalsDoc_lines_cdc5;
        var $bddvalsDoc_lines_cdc6;
        var $bddvalsDoc_lines_cdc7;
        var $bddvalsDoc_lines_cdc8;
        var $bddvalsDoc_lines_cdc9;
        var $bddvalsDoc_lines_cdc10;
        var $bddvalsDoc_lines_cdc11;
        var $bddvalsDoc_lines_cdc12;
        var $bddvalsDoc_lines_cdc13;
        var $bddvalsDoc_lines_cdc14;
        var $bddvalsDoc_lines_cdc15;
        var $bddvalsDoc_lines_cdc16;
        var $tableDoc_lines_cdc = "doc_lines_cdc";
        var $repeatDoc_lines_cdc = 1;

        /* Champs concernant la table Documents_events de la base de donnes Lundi Matin Business */
        var $bddvarsDocuments_events = array("ref_doc_event","ref_doc","date_event","id_event_type","event","ref_user");
        var $bddvalsDocuments_events1;
        var $bddvalsDocuments_events2;
        var $bddvalsDocuments_events3;
        var $bddvalsDocuments_events4;
        var $tableDocuments_events = "documents_events";
        var $repeatDocuments_events = 4;

        /* Tables dans lesquelles insrer du ct de Lundi Matin Business */
        var $tablesLMB = array("documents", "doc_cdc", "docs_lines", "doc_lines_cdc", "documents_events");

        /**
         * Constructeur de la classe CommandeLMB prenant un id en paramtre et appelant le constructeur de sa classe mre
         * @param $id l'id de la commande venant juste d'tre cre
         */
        function CommandeLMB($id) {
                // On instancie la connexion  la base
                $this->cnxThelia = new Cnx();
                $this->BaseObjLMB();
                // commande
                $this->tmpcmd = new Commande();
                $this->tmpcmd->charger($id);
                $query = "SELECT id FROM venteprod WHERE commande = $id";
                $resul = mysql_query($query, $this->cnxThelia->link);
                // date
                $this->date = date("Y-m-d H:i:s");
                $this->date_simple = date ("Y-m-d");
                // ref_contact
                $this->tmpcli = new Client();
                $this->tmpcli->charger_id($this->tmpcmd->client);
                $this->ref_contact = $this->transform1lettersId('C', $this->tmpcli->id);

                // pays
                // Rcupration du nom du pays (en majuscule)
                $query = "select titre from paysdesc where id = " . $this->tmpcli->pays;
                $resul = mysql_query($query, $this->cnxThelia->link);
                $pays = mysql_result($resul, 0);
                $pays = strtoupper($pays);
                // pays : $paysThelia contient le nom du pays en majuscule, il faut donc trouver son id correspondant
                $query = "select id_pays from pays where pays = $pays";
                $resul = mysql_query($query, $this->linkLMB);
                $this->pays = mysql_result($resul, 0);
                if (empty($this->pays)) {
                        $this->pays = 77;
                }

                // adresse complte
                $this->tmpadr = new VenteAdr();
                $this->tmpadr->charger($this->tmpcmd->adrlivr);

                // rcupration des id produits contenu dans la commande du client
                $query = 'select * from venteprod where commande =' . $this->tmpcmd->id;
                $resul = mysql_query($query, $this->cnxThelia->link);
                while($row = mysql_fetch_array($resul)) {
                        array_push($this->id_vente_prod, $row[id]);
                        array_push($this->ref_articles, $row[ref]);
                        array_push($this->quantite, $row[quantite]);
                        array_push($this->prix, $row[prixu]);
                }
                $this->repeatDocs_lines = count($this->ref_articles);
                $this->repeatDoc_lines_cdc = count($this->ref_articles);

                // rcupration du user thelia sur lmb
                $query = "select ref_user from users where pseudo LIKE 'thelia'";
                $resul = mysql_query($query, $this->linkLMB);
                $this->ref_user = mysql_result($resul, 0);
        }

        /**
         * Mise en forme pour la table Documents
         */
        function miseEnFormeDocuments() {
                //ref_doc
                $this->ref_doc_cdc = $this->transform3lettersId('CDC', $this->tmpcmd->id);
                //nom_contact
                $nom_contact = $this->tmpcli->nom . " " . $this->tmcli->prenom;
                //ref_adr_contact
                $ref_adr_contact = $this->transform3lettersId('ADR', $this->tmpcli->id);
                //adresse_contact
                $adresse_contact = $this->tmpcli->adresse1;
                //code_postal_contact
                $code_postal_contact = $this->tmpcli->cpostal;
                //ville_contact
                $ville_contact = $this->tmpcli->ville;
                //description
                $description = "Commande";
                //code_file
                $query = "select SHA1('" . $this->ref_doc_cdc . "')";
                $resul = mysql_query($query, $this->linkLMB);
                $code_file = mysql_result($resul, 0);
                $this->bddvalsDocuments = array($this->ref_doc_cdc, 2, 6,$this->ref_contact,$nom_contact,$adresse_contact,$code_postal_contact,$ville_contact,$this->pays, 'TTC',$description,$this->date, $code_file);

        }

        /**
         * Mise en forme pour la table Documents_events (4 insertions diffrentes)
         */
        function miseEnFormeDocuments_events1() {
                $ref_doc_event = $this->transformDocumentsEventsId('DCE', $this->tmpcmd->id) . 'a';
                $this->bddvalsDocuments_events1 = array($ref_doc_event, $this->ref_doc_cdc, $this->date, 1, '', $this->ref_user);
        }

        function miseEnFormeDocuments_events2() {
                $ref_doc_event = $this->transformDocumentsEventsId('DCE', $this->tmpcmd->id) . 'b';
                $this->bddvalsDocuments_events2 = array($ref_doc_event, $this->ref_doc_cdc, $this->date, 2, 'En cours', $this->ref_user);
        }

        function miseEnFormeDocuments_events3() {
                $ref_doc_event = $this->transformDocumentsEventsId('DCE', $this->tmpcmd->id) . 'c';
                $this->bddvalsDocuments_events3 = array($ref_doc_event, $this->ref_doc_cdc, $this->date, 2, 'A valider', $this->ref_user);
        }

        function miseEnFormeDocuments_events4() {
                $ref_doc_event = $this->transformDocumentsEventsId('DCE', $this->tmpcmd->id) . 'd';
                $this->bddvalsDocuments_events4 = array($ref_doc_event, $this->ref_doc_cdc, $this->date, 2, 'En cours', $this->ref_user);
        }

        /**
         * Mise en forme pour la table Doc_cdc
         */
        function miseEnFormeDoc_cdc() {
                $this->bddvalsDoc_cdc = array($this->ref_doc_cdc, $this->date_simple, $this->tmpadr->adresse1, $this->tmpadr->cpostal, $this->tmpadr->ville, $this->pays , $this->id_stock, $this->id_magasin);
        }

        /**
         * Mise en forme pour la table Docs_lines
         * @param $pos le numro de la ligne produit
         */
        function miseEnFormeDocs_lines($pos) {
                // cration d'un id doc_line incrment
                $query = "SELECT COUNT(*) FROM docs_lines";
                $resul = mysql_query($query, $this->linkLMB);
                $currentId = mysql_result($resul, 0);

                $ref_doc_lines = $this->transform3lettersId('RDL', $currentId + $pos);
                array_push($this->ref_doc_lines, $ref_doc_lines);

                $vente = new Venteprod();
                $vente->charger($this->id_vente_prod[$pos-1]);
                $produit = new Produit();
                $produit->charger($this->ref_articles[$pos-1]);
                $produitDesc = new Produitdesc();
                $produitDesc->charger($produit->id);

                $chaine = "bddvalsDocs_lines" . $pos;
                $this->$chaine = array($ref_doc_lines, $this->ref_doc_cdc, $produit->ref, $produitDesc->titre, $produitDesc->description, $this->quantite[$pos -1], $vente->prixu / (1 + $vente->tva/100), $vente->remise, $vente->tva, 1);
        }

        /**
         * Mise en forme pour la table Doc_lines_cdc
         * @param $pos le numro de la ligne produit
         */
        function miseEnFormeDoc_lines_cdc($pos) {
                $chaine = "bddvalsDoc_lines_cdc" . $pos;
                $this->$chaine = array ($this->ref_doc_lines[$pos - 1], $this->quantite[$pos -1]);
        }
}
?>
