<?php
include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
include_once(realpath(dirname(__FILE__)) . "./ClientLMB.class.php");
include_once(realpath(dirname(__FILE__)) . "./CommandeLMB.class.php");
include_once(realpath(dirname(__FILE__)) . "./BaseobjLMB.class.php");

/**
 * Classe qui permet de synchroniser les clients et les commandes vers l'application Lundi Matin Business
 *
 * @author Damien CELLE, Thibault GRILLE, Florian MERCIER, Jonathan PERICHON
 */
class SynchronisationLMB extends PluginsClassiques {
        // Chemin de lmb par rapport au dossier admin de Thelia
        var $IMAGES_LMB ="../../lmb/fichiers/images/articles/";

        // Chemin des images produits
        var $IMAGES_Thelia = "../client/gfx/photos/produit/";

        // Tableau contenant les tous les fichiers  modifier afin de faire suivre les images de Thelia vers LMB et vice-versa
        var $fichiersModifier = array("./ajax/classement.php", "./ajax/tri.php", "./parcourir.php", "./produit_modifier.php", "../client/shopbot/leguide.php", "../client/shopbot/netaff.php", "../client/shopbot/twenga.php", "../fonctions/boucles.php");


        /*
         * Constructeur
        */
        function SynchronisationLMB() {
                $this->PluginsClassiques();
        }

        /**
         * Permet de changer le rpertoire contenant les images lors de l'activation du plugin
         * @param $fichierModifier Le chemin et le nom du fichier dont il faut modifier le contenu
         */
        function majDossierImagePourLMBActivation($fichierModifier) {
                if(file_exists($fichierModifier)) {
                        $fic = file_get_contents($fichierModifier);
                        $fic = preg_replace('#' . $this->IMAGES_Thelia . '#', $this->IMAGES_LMB  , $fic);

                        $fp = fopen($fichierModifier, "w");
                        fputs($fp, $fic);
                        fclose($fp);
                }
        }

        /**
         * Permet de changer le rpertoire contenant les images lors de l'activation du plugin
         * @param $fichierModifier Le chemin et le nom du fichier dont il faut modifier le contenu
         */
        function majDossierImagePourLMBDesactivation($fichierModifier) {
                if(file_exists($fichierModifier)) {
                        $fic = file_get_contents($fichierModifier);
                        $fic = preg_replace('#' . $this->IMAGES_LMB . '#', $this->IMAGES_Thelia  , $fic);

                        $fp = fopen($fichierModifier, "w");
                        fputs($fp, $fic);
                        fclose($fp);
                }
        }

        /**
         * Lors de l'activation du plugin
         */
        function init() {
                // tableau contenant tous les fichier dans lesquels le chemin des images est  modifier
                foreach ($this->fichiersModifier as $fichier) {
                        $this->majDossierImagePourLMBActivation($fichier);
                }
        }
        

        /**
         * Lors de la dsactivation du plugin
         */
        function destroy() {
                // rtablissement des chemins d'origines pour les images des produits
                foreach ($this->fichiersModifier as $fichier) {
                        $this->majDossierImagePourLMBDesactivation($fichier);
                }
                // dsactivation des triggers
                $this->desactivationTriggers();

        }

        /**
         * Action effectue aprs chaque commande passe
         * @param $commande L'id de la commande
         */
        function aprescommande($commande) {
                $commandeLMB = new CommandeLMB($commande->id);
                $commandeLMB->miseEnForme();
                $commandeLMB->addToLMB();
        }

        /**
         * Action effectue aprs chaque cration de client
         * @param $client L'id du client
         */
        function apresclient($client) {

                $clientLMB = new ClientLMB($client->email);
                $clientLMB->miseEnForme();
                $clientLMB->addToLMB();
        }

        /**
         * Synchronisation de tous les clients
         */
        function toutSynchroniser() {
                $query = "select * from client";
                $resul = mysql_query($query, $this->link);

                while($row = mysql_fetch_array($resul)) {
                        $email = $row['email'];
                        $clientLMB = new ClientLMB($email);
                        $clientLMB->miseEnForme();
                        $clientLMB->addToLMB();
                }
        }



        /**
         * Desactivation des triggers mysql
         */
        function desactivationTriggers() {
                $baseobjlmb = new BaseobjLMB();
                //Connection  la base de donne MySQL
                $link = @mysql_connect($baseobjlmb->serverLMB, $baseobjlmb->loginLMB, $baseobjlmb->passwordLMB);
                mysql_select_db($baseobjlmb->bddLMB, $link);

                //Suppression du trigger de suppression d'un articles
                $suppressionTriggerSuppressionArticle = "drop trigger suppression_article;";
                $resul = mysql_query($suppressionTriggerSuppressionArticle, $link);


                //Suppression du trigger pour la modification de l'tat d'un commande
                $suppressionTriggerEtat = "drop trigger modification_etat_commande;";
                $resul = mysql_query($suppressionTriggerEtat, $link);


                //Suppression du trigger pour l'insertion d'un article
                $suppressionTriggerInsertion = "drop trigger insertion;";
                $resul = mysql_query($suppressionTriggerInsertion, $link);


                //Supression du trigger pour l'insertion d'un stock
                $suppressionTriggerMajStockINSERT = "drop trigger trig_maj_stock_insert;";
                $resul = mysql_query($suppressionTriggerMajStockINSERT, $link);


                //Suppression du trigger pour la mise--jour du stock
                $suppressionTriggerMajStockUPDATE = "drop trigger trig_maj_stock_update;";
                $resul = mysql_query($suppressionTriggerMajStockUPDATE, $link);


                //Suppression du trigger pour l'insertion de l'image d'un produit
                $suppressionTriggerMajImage = "drop trigger trig_maj_image_produit;";
                $resul = mysql_query($suppressionTriggerMajImage, $link);


                //Suppression de la procdure pour l'insertion d'un article
                $suppressionProcAjout = "drop procedure insertion_articles;";
                $resul = mysql_query($suppressionProcAjout, $link);


                //Suppression de la procdure pour la modification du stock d'un produit
                $suppressionProcStock = "drop procedure proc_maj_stock;";
                $resul = mysql_query($suppressionProcStock, $link);


                //Suppression de la procedure pour l'insertion de l'image d'un produit
                $suppressionProcMajImage = "drop procedure maj_image_produit;";
                $resul = mysql_query($suppressionProcMajImage, $link);


                //Suppression de la procedure pour la modification de l'tat d'une commande
                $suppressionProcEtatCom = "drop procedure modification_etat_commande_proc;";
                $resul = mysql_query($suppressionProcEtatCom, $link);


                //Suppression de la procedure pour la suppression d'un article
                $suppressionProcSuppArt = "drop procedure suppression_produit;";
                $resul = mysql_query($suppressionProcSuppArt, $link);

                mysql_close($link);

        }
}


?>