<?php
/*****************************************************************************************
 *
 * Fichier qui permet d'enregistrer/modifier/tester les informations de connexion
 *  la base de donnes de Lundi Matin Business depuis l'interface administration
 * de Thelia.
 *
 * @author Damien CELLE, Thibault GRILLE, Florian MERCIER, Jonathan PERICHON
 *
 *****************************************************************************************/
include_once(realpath(dirname(__FILE__)) . "./SynchronisationLMB.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/authplugins.php");
autorisation("SynchronisationLMB");

//Chargement des informations de connexion  la base de Lundi Matin Business depuis le fichier SynchronisationLMB.class.php
if (!isset($_POST['action']) || empty($_POST['action'])) {
        $serverLMB = chargerInfosLMB("serverLMB");
        $loginLMB = chargerInfosLMB("loginLMB");
        $bddLMB = chargerInfosLMB("bddLMB");
}
else if ($_POST['action'] == "Tout synchroniser les clients vers LMB") {
        $synchro = new SynchronisationLMB();
        $synchro->toutSynchroniser();
}

//Si l'on vient d'enregistrer des nouvelles informations de connexion  la base de Lundi Matin Business ou
//Si l'on vient de tester les paramtres de connexion
else {
        $serverLMB = mysql_real_escape_string($_POST['serverLMB']);
        $loginLMB = mysql_real_escape_string($_POST['loginLMB']);
        $bddLMB = mysql_real_escape_string($_POST['bddLMB']);
        $bddLMB = mysql_real_escape_string($_POST['bddLMB']);
}

/**
 * Fonction qui vrifie l'existence de la base de donnes passe en paramtre sur le serveur auquel on est connect
 * @param <string> $bdd La base de donnes dont on doit tester l'existence
 * @return <boolen> true si la table existe, false sinon
 */
function verificationExistenceBDD($bdd) {
        $listbdd = @mysql_list_dbs();
        while($row = mysql_fetch_object($listbdd)) {
                if ($row->Database == $bdd) {
                        return true;
                }
        }
        return false;
}

function toutSynchroniser() {
        $synchro = new SynchronisationLMB();
        $synchro->toutSynchroniser();
}

/**
 * Fonction qui sauvegarde les informations de connexion  la base de Lundi Matin Business saisies par l'administrateur
 * @param <string> $serverLMB Le serveur de base de donnes de Lundi Matin Business
 * @param <string> $loginLMB L'identifiant de connexion au serveur de base de donnes de Lundi Matin Business
 * @param <string> $passwordLMB Le mot de passe de connexion au serveur de base de donnes de Lundi Matin Business
 * @param <string> $bddLMB La base de donnes de Lundi Matin Business
 */
function sauvegardeInfosLMB($serverLMB, $loginLMB, $passwordLMB, $bddLMB) {
        if(file_exists("../client/plugins/SynchronisationLMB/BaseobjLMB.class.php")) { // le repertoire php courant est "admin"
                $fic = file_get_contents("../client/plugins/SynchronisationLMB/BaseobjLMB.class.php");

                $fic = preg_replace('#var \$serverLMB = "(.*)";#', 'var \$serverLMB = "' . $serverLMB .'";'  , $fic);
                $fic = preg_replace('#var \$loginLMB = "(.*)";#', 'var \$loginLMB = "' . $loginLMB .'";'  , $fic);
                $fic = preg_replace('#var \$bddLMB = "(.*)";#', 'var \$bddLMB = "' . $bddLMB .'";'  , $fic);
                $fic = preg_replace('#var \$passwordLMB = "(.*)";#', 'var \$passwordLMB = "' . $passwordLMB .'";'  , $fic);

                $fp = fopen("../client/plugins/SynchronisationLMB/BaseobjLMB.class.php", "w");
                fputs($fp, $fic);
                fclose($fp);

                activationTriggers($serverLMB, $loginLMB, $passwordLMB, $bddLMB);
        }
}

/**
 * Fonction qui rcupre la valeur du champ pass en paramtre en lisant dans le fichier SynchronisationLMB.class.php
 * @param <string> $nomDuChamp Nom du champ  charger
 * @return <string> Valeur du champ
 */
function chargerInfosLMB($nomDuChamp) {
        $page = "";
        if(file_exists("../client/plugins/SynchronisationLMB/BaseobjLMB.class.php")) {  // le repertoire php courant est "admin"
                $fp = fopen("../client/plugins/SynchronisationLMB/BaseobjLMB.class.php","r");
                while (!feof($fp)) {
                        $page .= fgets($fp, 4096);
                }

                $titre = preg_match('#var \$'. $nomDuChamp . ' = "(.*)";#',$page, $regs);

                fclose($fp);

        }
        return $regs[1];
}

/**
 * Activation des triggers mysql
 */
function activationTriggers($server, $login, $pass, $bdd) {
        $bddThelia = "thelia";

        //Connection  la base de donne MySQL
        $link = @mysql_connect($server, $login, $pass);
        mysql_select_db($bdd, $link);



        //Creation de la procedure pour l'insertion d'un produit
        $creationProcAjout =
            "CREATE PROCEDURE insertion_articles (ref_art VARCHAR(32), no_matter1 INT, no_matter2 INT, prix_ht FLOAT)
		BEGIN
		DECLARE existance INT;
		DECLARE	tva_art FLOAT;
		DECLARE	prix FLOAT;
		DECLARE idTva INT;
		DECLARE modele_article text;
		DECLARE poid_article FLOAT;
		DECLARE garantie_article INT;
		DECLARE libelle text;
		DECLARE chapo text;
		DECLARE description TEXT;
		DECLARE idProdThelia INT;
		select count(*) into existance from " . $bddThelia . ".produit where ref = ref_art;
		if existance = 0
		then
			SET prix = prix_ht;
			select id_tva into idTva from articles where ref_article = ref_art;
			if idTva IS NULL
				then
					SET tva_art = 0;
			else
				select tva into tva_art from tvas where id_tva = idTva;
				SET prix = prix_ht + (prix_ht*tva_art)/100;
			end if;
			select modele into modele_article from articles where ref_article = ref_art;
			if modele_article LIKE 'materiel'
			then
				select poids into poid_article from articles_modele_materiel where ref_article = ref_art;
				select duree_garantie into garantie_article from articles_modele_materiel where ref_article = ref_art;
			else
				SET poid_article = 0;
				SET garantie_article = 0;
			end if;
			select lib_article into libelle from articles where ref_article = ref_art;
			select desc_courte into chapo from articles where ref_article = ref_art;
			select desc_longue into description from articles where ref_article = ref_art;
			insert into " . $bddThelia . ".produit values ('', ref_art, sysdate(), prix, 0, 0, prix, 0, 0, 0, 0, 0, garantie_article, poid_article, tva_art, 1);
			select id into idProdThelia from " . $bddThelia . ".produit where ref = ref_art;
			insert into " . $bddThelia . ".produitdesc values ('', idProdThelia, libelle, chapo, description, '', 1);
		end if;
		END;";
        $resul = mysql_query($creationProcAjout, $link);


        //creation de la procedure pour la suppression d'un produits dans thelia
        $creationProcSuppression =
            "CREATE PROCEDURE suppression_produit (ref_prod VARCHAR(32))
		BEGIN
			DECLARE id_prod INT;
			DECLARE exist INT;
			SET exist = 0;
			SELECT id INTO id_prod FROM " . $bddThelia . ".produit WHERE ref = ref_prod;
			SELECT count(*) into exist FROM " . $bddThelia . ".image WHERE produit = id_prod;
			DELETE FROM " . $bddThelia . ".produitdesc WHERE produit = id_prod;
			IF exist != 0
				THEN
					DELETE FROM " . $bddThelia . ".image WHERE produit = id_prod;
			END IF;
			DELETE FROM " . $bddThelia . ".produit WHERE ref = ref_produit;
		END;";
        $resul = mysql_query($creationProcSuppression, $link);


        //creation de la procedure pour la mise a jour du stock des produits dans thelia
        $creationProcStock =
            "CREATE PROCEDURE proc_maj_stock (ref_prod VARCHAR(32))
		BEGIN
			DECLARE quantite INT;
			select qte into quantite from stocks_articles where ref_article = ref_prod;
			UPDATE " . $bddThelia . ".produit SET stock = quantite, ligne = 1 where ref = ref_prod;
		END;";
        $resul = mysql_query($creationProcStock, $link);


        //creation de la procedure pour la mise a jour de m'image d'un produit
        $creationProcMajImage =
            "CREATE PROCEDURE maj_image_produit (ref_article VARCHAR(32), id_image_art INT, ordre INT)
		BEGIN
			DECLARE ref_prod VARCHAR(32);
			DECLARE file VARCHAR(64);
			DECLARE id_prod INT;
			select lib_file into file from images_articles where id_image = id_image_art;
			select id into id_prod from " . $bddThelia . ".produit where ref = ref_article;
			insert into " . $bddThelia . ".image values ('', id_prod, 0, 0, 0, file, 0);
		END;";
        $resul = mysql_query($creationProcMajImage, $link);


        //Creation de la procedure pour la modification de l'tat d'une commande dans thelia  partir de LMB
        $creationProcEtat =
            "CREATE PROCEDURE modification_etat_commande_proc (ref_doc_src VARCHAR(32), ref_doc_dest VARCHAR(32), no_matter INT)
		BEGIN
			DECLARE doc_commande_src VARCHAR(4);
			DECLARE doc_commande_dest VARCHAR(4);
			DECLARE doc_cdc VARCHAR(32);
			DECLARE doc_blc VARCHAR(32);
			DECLARE id_format INT;
			select SUBSTR(ref_doc_src, 1, 3) into doc_commande_src;
			select SUBSTR(ref_doc_dest, 1, 3) into doc_commande_dest;
			IF doc_commande_dest LIKE 'BLC'
				THEN
					select ref_doc_source into doc_cdc from documents_liaisons where ref_doc_destination = ref_doc_dest;
					select miseEnFormeId(doc_cdc) into id_format;
					UPDATE " . $bddThelia . ".commande SET statut = 4 where id = id_format;
			END IF;
			IF doc_commande_dest LIKE 'FAC'
				THEN
					select ref_doc_source into doc_blc from documents_liaisons where ref_doc_destination = ref_doc_dest;
					select ref_doc_source into doc_cdc from documents_liaisons where ref_doc_destination = doc_blc;
					select miseEnFormeId(doc_cdc) into id_format;
					UPDATE " . $bddThelia . ".commande SET statut = 2 where id = id_format;
			END IF;
		END;";
        $resul = mysql_query($creationProcEtat, $link);


        //Creation de la fonction de mise en forme de l'id de LMB ver thelia
        $creationFunc =
            "CREATE FUNCTION miseEnFormeId(id VARCHAR(30)) RETURNS INT
		DETERMINISTIC
	    BEGIN
			DECLARE premierePartieId VARCHAR(10);
			DECLARE deuxiemePartieId VARCHAR(10);
			DECLARE premierePartieIdSans0 VARCHAR(10);
			DECLARE deuxiemePartieIdSans0 VARCHAR(10);
			DECLARE chaineId VARCHAR(10);
			DECLARE C3 VARCHAR(10);
			DECLARE i INT;
			DECLARE newId INT;
			SET premierePartieIdSans0 = '';
			SET deuxiemePartieIdSans0 = '';
			SET premierePartieId = substring(id,5,6);
			SET deuxiemePartieId = substring(id,12,5);
			SET i = 0;
			while i < LENGTH(premierePartieId) DO
				SET i = i + 1;
				SET C3 = substring(premierePartieId, i, 1);
				if C3 NOT LIKE '0'
					then
						SET premierePartieIdSans0 = substring(premierePartieId, i);
						SET i = 100;
				end if;
			end while;
		SET i = 0;
		while i < LENGTH(deuxiemePartieId) DO
			SET i = i + 1;
			SET C3 = substring(deuxiemePartieId, i, 1);
			if C3 NOT LIKE '0'
				then
					SET deuxiemePartieIdSans0 = substring(deuxiemePartieId, i);
					SET i = 100;
			end if;
		end while;
		SET chaineId = concat(premierePartieIdSans0, deuxiemePartieIdSans0);
		SET newId = CAST(chaineId AS UNSIGNED);
		RETURN newId;
		END;";
        $resul = mysql_query($creationFunc, $link);


        //Creation du trigger pour l'insertion d'un produit
        $creationTriggerAjout =
            "CREATE TRIGGER insertion AFTER INSERT ON articles_tarifs
		FOR EACH ROW
		BEGIN
                CALL insertion_articles(NEW.ref_article, NEW.id_tarif, NEW.indice_qte, NEW.pu_ht);
		END;";
        $resul = mysql_query($creationTriggerAjout, $link);


        //Creation du trigger pour la mise  jour du stock des produits
        $creationTriggerMajStockINSERT =
            "CREATE TRIGGER trig_maj_stock_insert AFTER INSERT ON stocks_articles
		FOR EACH ROW
		BEGIN
				CALL proc_maj_stock(NEW.ref_article);
		END;";
        $resul = mysql_query($creationTriggerMajStockINSERT, $link);


        //Creation du trigger pour la mise  jour du stock des produits
        $creationTriggerMajStockUPDATE =
            "CREATE TRIGGER trig_maj_stock_update AFTER UPDATE ON stocks_articles
		FOR EACH ROW
		BEGIN
				CALL proc_maj_stock(NEW.ref_article);
		END;";
        $resul = mysql_query($creationTriggerMajStockUPDATE, $link);


        //creation du trigger pour la mise  jour de l'image d'un produit
        $creationTriggerMajImage =
            "CREATE TRIGGER trig_maj_image_produit AFTER INSERT ON articles_images
		FOR EACH ROW
		BEGIN
                CALL maj_image_produit(NEW.ref_article, NEW.id_image, NEW.ordre);
		END;";
        $resul = mysql_query($creationTriggerMajImage, $link);


        //Creation du trigger pour la l'insertion d'un nouvelle tat de la commande dans LMB
        $creationTriggerEtat =
            "CREATE TRIGGER modification_etat_commande AFTER INSERT ON documents_liaisons
		FOR EACH ROW
		BEGIN
                CALL modification_etat_commande_proc(NEW.ref_doc_source, NEW.ref_doc_destination, NEW.active);
		END;";
        $resul = mysql_query($creationTriggerEtat, $link);


        //creation du trigger pour la suppression d'un produit
        $creationTriggerSuppression =
            "CREATE TRIGGER suppression_article AFTER DELETE ON articles
		FOR EACH ROW
		BEGIN
                CALL suppression_produit(NEW.ref_article);
		END;";
        $resul = mysql_query($creationTriggerSuppression, $link);


        //mysql_close($link);
}


//Si il y a une modification valable
if ($_POST['action'] == "Enregistrer les modifications" && !empty($_POST['serverLMB']) && !empty($_POST['loginLMB']) && !empty($_POST['bddLMB'])) {
        sauvegardeInfosLMB($serverLMB, $loginLMB, $passwordLMB, $bddLMB);
}?>

<style type="text/css">
        .valide {
                font-size: 15px;
                color: green;
        }

        .erreur {
                font-size: 15px;
                color: red;
        }

        td {
                height: 30px;
                padding: 4px;
        }

        .boutons {
                width: 250px;
        }
</style>

<div id="contenu_int">
        <p class="geneva11Reg_3B4B5B"><a href="accueil.php" class="lien04">Accueil</a><img
                        src="gfx/suivant.gif" width="12" height="9" border="0" alt="suivant" /><a
                        href="#" class="lien04">Synchronisation avec Lundi Matin Business</a></p>

        <div id="bloc_description">
                <div class="entete">
                        <div class="titre">Synchronisation avec Lundi Matin Business</div>
                </div>

                <form action="module.php?nom=SynchronisationLMB" name="infosLMB"
                      id="infosLMB" method="post" enctype="multipart/form-data">
                        <table width="100%" cellpadding="5" cellspacing="0">
                                <tr class="claire">
                                        <td class="designation">Serveur de base de donnes de Lundi Matin
		Business :</td>
                                        <td style="text-align: center;"><input type="text" size="20"
                                                                               name="serverLMB" value="<?php echo $serverLMB; ?>" /></td>
                                </tr>
                                <tr class="fonce">
                                        <td class="designation">Login pour se connecter  ce serveur :</td>
                                        <td style="text-align: center;"><input type="text" size="20"
                                                                               name="loginLMB" value="<?php echo $loginLMB; ?>" /></td>
                                </tr>
                                <tr class="claire">
                                        <td class="designation">Mot de passe pour se connecter  ce serveur :
                                        </td>
                                        <td style="text-align: center;"><input type="password" size="20"
                                                                               name="passwordLMB" value="" /></td>
                                </tr>
                                <tr class="fonce">
                                        <td class="designation">Base de donnes utilise :</td>
                                        <td style="text-align: center;"><input type="text" size="20"
                                                                               name="bddLMB" value="<?php echo $bddLMB; ?>" /></td>
                                </tr>
                                <tr class="claire">
                                        <td colspan="2" style="text-align: center;"><input name="action"
                                                                                           type="submit" value="Tester les paramtres de connexion"
                                                                                           class="boutons" /></td>
                                </tr>
                                <tr class="fonce">
                                        <td colspan="2" style="text-align: center;"><input name="action"
                                                                                           type="submit" value="Enregistrer les modifications" class="boutons" /></td>
                                </tr>
                                <tr class="claire">
                                        <td colspan="2" style="text-align: center;"><input name="action"
                                                                                           type="submit" value="Tout synchroniser les clients vers LMB" class="boutons" /></td>
                                </tr>
                        </table>
                </form>

                <?php

                //Affichage des messages

                //Si il y a une modification
                if ($_POST['action'] == "Enregistrer les modifications") {
                        //Modification enregistre dans le fichier
                        if (!empty($_POST['serverLMB']) && !empty($_POST['loginLMB']) && !empty($_POST['bddLMB']))
                                echo "<span class=\"valide\">Les modifications ont bien tes effectues</span>";
                        //Si tous les champs ne sont pas saisies
                        else echo "<span class=\"erreur\">Tous les champs ncessaires  la connexion  la base de Lundi Matin Business ne sont pas saisies</span>";
                }
                //Test des informations de connexion
                else if ($_POST['action'] == "Tester les paramtres de connexion") {
                        if(isset($_POST['serverLMB']) && isset($_POST['loginLMB'])  && isset($_POST['bddLMB'])) {
                                if($cnx = @mysql_connect($_POST['serverLMB'], $_POST['loginLMB'], $_POST['passwordLMB'])) {
                                        //Connexion tablie
                                        if (verificationExistenceBDD($_POST['bddLMB']))
                                                echo "<span class=\"valide\">Connexion la base de Lundi Matin Business tablie</span>";
                                        //Base inexistante sur le serveur auquel on est connect
                                        else echo "<span class=\"erreur\">Base inexistante</span>";
                                }
                                //Mauvais Login et/ou password et/ou serveur de connexion
                                else echo "<span class=\"erreur\">Erreur lors de la connexion</span>";
                        }
                        //Si tous les champs ne sont pas saisies
                        else echo "<span class=\"erreur\">Tous les champs ncessaires  la connexion  la base de Lundi Matin Business ne sont pas saisies</span>";
                }

                //Avertissement
                else echo "<span class=\"erreur\">Il est fortement recommand de tester la connexion avant de sauvegarder les infos de connexion.</span>";
                ?></div>
</div>
